package org.netkernel.mod.cron.services;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.mod.cron.transport.CronTransport;
import org.netkernel.mod.cron.transport.NetKernelRequestJob;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.urii.ISpaceWithIdentity;
import org.quartz.Scheduler;

public class CronNewAccessor extends StandardAccessorImpl
{
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		ISpaceWithIdentity injectionSpace=CronUtils.getInjectionSpace(aContext,4);
		if (injectionSpace==null)
		{	throw aContext.createFormattedException("EX_INDETERMINATE_JOB_SPACE", null, null, null);
		}
		
		IHDSNode job=aContext.source("arg:job", IHDSNode.class);
		if (job.getName()==null) job=job.getFirstNode("*");
		String space=injectionSpace.getIdentifier().toString();
		String version=injectionSpace.getVersion().toString();
		Scheduler s = CronTransport.getSingleton().getScheduler();
		CronUtils.validateJob(job, aContext);
		CronUtils.addJob(job,space,version,NetKernelRequestJob.KEY_TYPE_DIRECT,s,aContext);
	}
}
